	JSR	LAB_EVST	; evaluate string
	sta	str_ln		; save string length
	beq	DOSERR1		; branch if null string
	
	JSR	LAB_MSSP	; make string space A bytes long A=length,
				; X=Sutill=ptr low byte, Y=Sutilh=ptr high byte
	STX	str_pl		; save string pointer low byte
	STY	str_ph		; save string pointer high byte
	STA	str_ln

send_cmd
	lda 	#$ff	; system LFN
	jsr 	CLOSE	; close it just in case 

	ldx 	CMD_DEV	; get device
	cpx 	#$08	; Below 8?
	bmi 	DOSERR3	; yes...error
	cpx 	#$0b	; above 11
	bcs 	DOSERR3	; yes...error

			; setup OPEN params
	LDA 	#$ff	; handle
	LDY	#$6f	; SA 15 OR 60h
	JSR 	SETLFS
	JSR 	OPEN	; open device
	lda 	#$6f	; DATA SA 15 OR 60h
	jsr 	LISTEN	; LISTEN 
	lda 	#$6f	; DATA SA 15 OR 60h
	jsr 	SECOND	; send secondary address

	ldy	#$00
next_char1
	lda 	str_pl,y
	beq 	dos_done
	jsr 	CIOUT		; send char to IEEE
	iny
	cpy	str_ln
	beq	dos_done
	clv 
	bvc 	next_char1	; branch always

dos_done
	jsr 	UNLSN

	lda 	CMD_DEV
	jsr 	TALK		; TALK
	lda 	#$6f		; DATA SA 15
	jsr 	SECOND		; send secondary address

next_char2
	jsr 	ACPTR		; read byte from IEEE bus
	cmp 	#$0d		; last byte = CR?		
	beq 	done2
	jsr 	OUTPUT		; write char to screen
	clv 
	bvc 	next_char2	; branch always

done2
	jsr 	OUTPUT		; write char to screen
	jsr 	UNTLK		; UNTALK
	JSR 	CLRCH
	LDA 	#$FF		; Now close the file
	JSR 	CLOSE
	rts			; return to BASIC
	
	
DOSERR1
	jmp	LAB_FCER

DOSERR2
	jmp	LAB_SNER
	
DOSERR3
	LDX	#$38		; "illegal device" error
	JMP	LAB_XERR	; jump to error routine

